const { generate } = require('./codegen');
const { parse } = require('./parser');
const { baseOptions } = require('./options');

/**
 * @param template {String} Template string.
 * @param options {Object} Compiler options.
 */
function compile(template, options) {
  const parsed = parse(template.trim(), options);
  const generated = generate(parsed, options);
  const { ast, imported, exported } = parsed;
  console.log('res', Object.assign({ ast, imported, exported }, generated));
  return Object.assign({ ast, imported, exported }, generated);
}

module.exports = exports = compile;
exports.parse = parse;
exports.generate = generate;
exports.baseOptions = baseOptions;
